#include <iostream>

using namespace std;

int main()
{
    long int n,m,i,j,x=0,y=0,k,sum,szamlalo=1;
    cin>>n>>m;
    long int a[n];
    long int b[m*m];
    for(i=0;i<n;i++)
    {
        cin>>a[i];
    }
    for(i=0;i<m*m;i++)
    {

        cin>>b[i];

    }
    for(i=0;i<n;i++)
    {
      for(j=0;j<m*m-2;j++)
      {
          if(b[j]==b[j+1]||b[j]==b[j+2])
          {
              x+=a[i]*(b[j-1]-b[j+2]);
          }
          x+=a[i]*(b[j]-b[j+1]);
          y+=a[i]*(b[j+1]-b[j]);
        k=max(x,y);
      }

    }
    cout<<k+1<<endl;
    return 0;
}